#include "llvm/Pass.h"
#include "llvm/Function.h"
#include "llvm/Module.h"
#include "llvm/Support/CFG.h"
#include "llvm/Support/PredIteratorCache.h"
#include "llvm/Analysis/LoopInfo.h"
#include "llvm/Analysis/LoopPass.h"
#include "llvm/PassAnalysisSupport.h"
#include "llvm/CallGraphSCCPass.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/Assembly/Writer.h"
#include "llvm/Assembly/PrintModulePass.h"
#include "llvm/Assembly/AssemblyAnnotationWriter.h"
#include "llvm/ADT/PostOrderIterator.h"
#include "llvm/Type.h"
#include "llvm/DerivedTypes.h"
#include "llvm/Transforms/Utils/BasicBlockUtils.h"
#include "llvm/Transforms/Utils/FunctionUtils.h"
#include "llvm/ADT/Statistic.h"
#include "llvm/Transforms/Scalar.h"
#include "llvm/Analysis/Dominators.h"
#include "llvm/Transforms/IPO.h"
#include "llvm/Support/CommandLine.h"
#include "llvm/Support/InstIterator.h"
#include "llvm/Transforms/Custom.h"
#include <string>
#include <stdio.h>
#include <iostream>
#include <vector>
#include <stack>
#include <sstream>
#include <set>
#include <fstream>

//
//From Ryan Taylor
//

using namespace llvm;

namespace  {
    struct PrintPhi: public FunctionPass {
    static char ID;
    explicit PrintPhi() : FunctionPass(ID) {
        /// For Windows - because its loader is deficient.
        initializePrintPhiPass(*PassRegistry::getPassRegistry());
      }
    
    
    virtual bool runOnFunction(Function &F) {
    Instruction *Instritr;
      for (Function::iterator BBitr = F.begin(); BBitr!= F.end();++BBitr) {
        for (BasicBlock::iterator instItr = BBitr->begin(); instItr != BBitr->end(); ++instItr) {
          Instritr = instItr;
          if (isa<PHINode>(Instritr)) {
            errs()<<*Instritr<<"\n";
          }
        }
      }
    return false;
  }
  };
}

char PrintPhi::ID = 1;
//static RegisterPass<PrintPhi> X("a-print-phi", "Aarons Print Phi Pass", false, false);

///For Windows - because its loader is deficient.
INITIALIZE_PASS(PrintPhi, "a-print-phi", "Aarons Print Phi Pass", false, false)
///For Windows - because its loader is deficient.
FunctionPass *llvm::createPrintPhiPass()
{
  return new PrintPhi();
}
